#line 1 "udpservice.c"
























 
#line 1 "udpservice.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "udpservice.h"
#line 1 "ipservice.h"
























 





#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 32 "udpservice.h"







struct _UDPLayerInstanceRec ;
typedef struct _UDPLayerInstanceRec * PtrUDPLayerInstanceRecT ;

struct _UDPSocketDescriptionRec ;
typedef struct _UDPSocketDescriptionRec * PtrUDPSocketDescriptionRecT ;

typedef void ( * AnyUDPRecvEventServProcT ) ( ULONG    ,
                                              USHORT   ,
                                              ULONG    ,
                                              USHORT   ,
                                              void *   ,
                                              USHORT   ) ;

typedef void ( * SocketUDPRecvEventServProcT ) ( PtrUDPSocketDescriptionRecT   ,
                                                 ULONG                         ,
                                                 USHORT                        ,
                                                 ULONG                         ,
                                                 USHORT                        ,
                                                 void *                        ,
                                                 USHORT                        ) ;

typedef struct _UDPSocketDescriptionRec
               {
                 USHORT                       ListenPortNo ;
                 SocketUDPRecvEventServProcT  ListenService ;
                 PtrUDPLayerInstanceRecT      UDPLayerInstanceLink ;
                 PtrUDPSocketDescriptionRecT  NextSocketLink ;
               } UDPSocketDescriptionRecT ;

typedef struct _UDPLayerInstanceRec
               { PtrIPLayerInstanceRecT       IPLayerInstance ;
                 AnyUDPRecvEventServProcT     DefaultListenService ;
                 PtrUDPSocketDescriptionRecT  ListenSocketTopEntry ;
                 USHORT                       LastLocalPort ;
               } UDPLayerInstanceRecT ;






extern USHORT UDPSendData ( PtrUDPSocketDescriptionRecT   ,
                            ULONG                         ,
                            USHORT                        ,
                            void *                        ,
                            USHORT                        ) ;

extern PtrUDPSocketDescriptionRecT AllocateUDPSocket ( PtrUDPLayerInstanceRecT   ) ;

extern void DeallocateUDPSocket ( PtrUDPSocketDescriptionRecT   ) ;




extern USHORT BindUDPSocket ( PtrUDPSocketDescriptionRecT   ,
                              USHORT                        ) ;

extern void SetUDPListen ( PtrUDPSocketDescriptionRecT   ,
                           SocketUDPRecvEventServProcT   ) ;

extern void SetDefaultUDPListen ( PtrUDPLayerInstanceRecT    ,
                                  AnyUDPRecvEventServProcT   ) ;

extern PtrUDPSocketDescriptionRecT CreateUDPSocket ( PtrUDPLayerInstanceRecT   ) ;

extern void UDPInitInstance ( PtrUDPLayerInstanceRecT   ,
                              PtrIPLayerInstanceRecT    ) ;

extern PtrUDPLayerInstanceRecT GetUDPInstance ( PtrUDPSocketDescriptionRecT   ) ;

extern PtrIPLayerInstanceRecT GetIPInstanceFromUDPInstance ( PtrUDPLayerInstanceRecT   ) ;

extern PtrUDPLayerInstanceRecT StandardAddUDPInstance ( PtrIPLayerInstanceRecT   ) ;

#line 27 "udpservice.c"
#line 28 "udpservice.c"
#line 29 "udpservice.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 30 "udpservice.c"
#line 1 "trace.h"
























 




#line 31 "trace.h"
#line 32 "trace.h"
#line 33 "trace.h"

extern void traceDHCP ( UCHAR * UDPDataBuffer , USHORT UDPDataSize ) ;


extern void TraceUDPHeader ( PtrOSFrameRecT   ) ;

extern void TraceFrame ( PtrOSFrameRecT   ) ;

extern void TraceIPHeader ( IPHeaderRecT *   ) ;

extern void TraceETHHeader ( EtherPackedHeaderRecT *   ) ;

extern void TraceMAC ( UCHAR *   ) ;

extern void TraceIP ( ULONG   ) ;

extern void TraceUCHAR ( UCHAR   ) ;

extern void TraceUSHORT ( USHORT   ) ;

extern void TraceUSHORTdec ( USHORT   ) ;

extern void TraceULONG ( ULONG   ) ;

extern void traceBlock( UCHAR *   , USHORT   ) ;

#line 31 "udpservice.c"







static UDPSocketDescriptionRecT UDPSocketArray [ 8 ] ;
static UCHAR UDPSocketSwitch [ 8 ] ;


static USHORT CheckUnique ( PtrUDPLayerInstanceRecT UDPLayerInstance ,
                            USHORT                  PortNo )
{
  USHORT Loop ;
  PtrUDPSocketDescriptionRecT TempSocket ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( UDPSocketSwitch [ Loop ] )
    {
      TempSocket = & UDPSocketArray [ Loop ] ;
      if ( TempSocket -> ListenPortNo == PortNo )
        return ( ( 0 ) ) ;
    }   ;
  }   ;
  return ( ( 1 ) ) ;
}  


static USHORT AllocUDPPortN ( PtrUDPLayerInstanceRecT UDPLayerInstance )
{
  USHORT PortNo ;
  USHORT Unique ;
   
  for ( ; ; )
  {
    PortNo = UDPLayerInstance -> LastLocalPort ++ ;
    if ( UDPLayerInstance -> LastLocalPort > 4095 )
      UDPLayerInstance -> LastLocalPort = 2048 ;
    Unique = CheckUnique ( UDPLayerInstance , PortNo ) ;
    if ( Unique )
      return ( PortNo ) ;
  }   ;
}  


PtrUDPSocketDescriptionRecT AllocateUDPSocket ( PtrUDPLayerInstanceRecT UDPLayerInstance )
{
  USHORT Loop ;
  PtrUDPSocketDescriptionRecT NewSocket ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( ! UDPSocketSwitch [ Loop ] )
    {
      UDPSocketSwitch [ Loop ] = 1 ;
      NewSocket = & UDPSocketArray [ Loop ] ;
      NewSocket -> NextSocketLink = ( void * ) 0 ;
      NewSocket -> UDPLayerInstanceLink = UDPLayerInstance ;
      NewSocket -> ListenService = ( void * ) 0 ;
      NewSocket -> ListenPortNo = AllocUDPPortN ( UDPLayerInstance ) ;
      return ( NewSocket ) ;
    }   ;
  }   ;
  return ( ( void * ) 0 ) ;
}  


void DeallocateUDPSocket ( PtrUDPSocketDescriptionRecT UDPSocket )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  PtrUDPSocketDescriptionRecT TempSocket ;
  USHORT Loop ;
   
  UDPLayerInstance = UDPSocket -> UDPLayerInstanceLink ;
  if ( UDPLayerInstance -> ListenSocketTopEntry )
  {
    TempSocket = UDPLayerInstance -> ListenSocketTopEntry ;
    if ( TempSocket == UDPSocket )
    {
      UDPLayerInstance -> ListenSocketTopEntry = UDPSocket -> NextSocketLink ;
    }  
    else
    {
      while ( TempSocket )
      {
        if ( TempSocket -> NextSocketLink == UDPSocket )
        {
          TempSocket -> NextSocketLink = UDPSocket -> NextSocketLink ;
          break ;
        }   ;
        TempSocket = TempSocket -> NextSocketLink ;
      }   ;
    }   ;
  }   ;
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    TempSocket = & UDPSocketArray [ Loop ] ;
    if ( UDPSocket == TempSocket )
    {
      UDPSocketSwitch [ Loop ] = ( 0 ) ;
      break ;
    }   ;
  }   ;
}  


static PtrUDPSocketDescriptionRecT LocateUDPListen ( PtrUDPLayerInstanceRecT UDPLayerInstance ,
                                                     USHORT                  UDPPortNo )
{
  PtrUDPSocketDescriptionRecT TempSocket ;
   
  TempSocket = UDPLayerInstance -> ListenSocketTopEntry ;
  while ( TempSocket )
  {
    if ( TempSocket -> ListenPortNo == UDPPortNo )
      break ;
    TempSocket = TempSocket -> NextSocketLink ;
  }   ;
  return ( TempSocket ) ;
}  


static void ProcessUDPPacked ( PtrIPLayerInstanceRecT IPLayerInstance ,
                               IPHeaderRecT *         IPHeader ,
                               PtrOSFrameRecT         Frame )
{
  USHORT SourcePortNo ;
  USHORT DestinationPortNo ;
  USHORT UDPPackedSize ;
  USHORT UDPCheckSum ;
  USHORT TestUDPCheckSum ;
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  PtrUDPSocketDescriptionRecT UDPSocket ;
  SocketUDPRecvEventServProcT UDPDataConsumer ;
  USHORT * CheckSumPointer ;
  void * UDPDataBuffer ;
  void * AllUDPDataBuffer ;
   
  UDPLayerInstance = ( PtrUDPLayerInstanceRecT ) IPLayerInstance -> UDPInstanceEntry ;
TraceUDPHeader ( Frame ) ;
  AllUDPDataBuffer = ( void * ) ( Frame -> Data + Frame -> Index ) ;
  SourcePortNo = ReadUSHORTSwapField ( Frame ) ;
  DestinationPortNo = ReadUSHORTSwapField ( Frame ) ;
  UDPPackedSize = ReadUSHORTSwapField ( Frame ) ;
  CheckSumPointer = ( USHORT * ) ( & Frame -> Data [ Frame -> Index ] ) ;
  UDPCheckSum = ReadUSHORTSwapField ( Frame ) ;
  if ( UDPPackedSize <= 8 )
    return ;
  UDPDataBuffer = ( void * ) ( Frame -> Data + Frame -> Index ) ;
  if ( UDPCheckSum )
  {
    * CheckSumPointer = 0 ;
    TestUDPCheckSum = CalculateUDPChecksum ( IPHeader -> SourceIPAddress , IPHeader -> DestinationIPAddress ,
                                             AllUDPDataBuffer , UDPPackedSize ) ;
    if ( ! TestUDPCheckSum )
      TestUDPCheckSum = 0xFFFF ;
    if ( UDPCheckSum != TestUDPCheckSum )
    {
      return ;
    }   ;
  }   ;
  UDPSocket = LocateUDPListen ( UDPLayerInstance , DestinationPortNo ) ;
  if ( UDPSocket )
  {
    UDPDataConsumer = UDPSocket -> ListenService ;
    if ( UDPDataConsumer )
      UDPDataConsumer ( UDPSocket , IPHeader -> SourceIPAddress , SourcePortNo ,
                        IPHeader -> DestinationIPAddress , DestinationPortNo ,
                        UDPDataBuffer , UDPPackedSize - 8 ) ;
  }  
  else
  {
    if ( UDPLayerInstance -> DefaultListenService )
      UDPLayerInstance -> DefaultListenService ( IPHeader -> SourceIPAddress , SourcePortNo ,
                                                 IPHeader -> DestinationIPAddress , DestinationPortNo ,
                                                 UDPDataBuffer , UDPPackedSize - 8 ) ;
  }   ;
}  


static void KillUDPData ( ULONG   SenderIPAddress ,
                          USHORT  SenderPortNo ,
                          ULONG   DestIPAddress ,
                          USHORT  DestPortNo ,
                          void *  UDPDataBuffer ,
                          USHORT  UDPDataSize )
{
}  


USHORT BindUDPSocket ( PtrUDPSocketDescriptionRecT UDPSocket ,
                       USHORT                      PortNo )
{
  if ( UDPSocket -> ListenPortNo == PortNo )
  {
    return ( 0 ) ;
  }   ;
  if ( CheckUnique ( UDPSocket -> UDPLayerInstanceLink , PortNo ) )
  {
    UDPSocket -> ListenPortNo = PortNo ;
    return ( 0 ) ;
  }  
  else
  {
    return ( 1 ) ;
  }   ;
}  


USHORT UDPSendData ( PtrUDPSocketDescriptionRecT Socket ,
                     ULONG                       DestIPAddress ,
                     USHORT                      DestPortNo ,
                     void *                      DataBufferPtr ,
                     USHORT                      DataSize )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
  EMACInstanceRecT * InterfInstance ;
  void * AllUDPDataBuffer ;
  ULONG TargetAddress ;
  PtrOSFrameRecT OutFrame ;
  USHORT CheckSum ;
  USHORT BCMode ;
  USHORT Loop ;
  USHORT CheckSumOffset ;
   
  if ( Socket )
  {
    if ( ! DataSize )
      return ( 1 ) ;
    UDPLayerInstance = Socket -> UDPLayerInstanceLink ;
    if ( DataSize > 1536 - 20 - 8 )
      return ( 2 ) ;
    IPLayerInstance = UDPLayerInstance -> IPLayerInstance ;
    InterfInstance = IPLayerInstance -> InterfaceInstance ;
    BCMode = ( 0 ) ;
    if ( DestIPAddress == 0xFFFFFFFF )
    {
      BCMode = ( 1 ) ;
      TargetAddress = DestIPAddress ;
    }  
    else
    {
      if ( ( DestIPAddress & IPLayerInstance -> MyLocalNetMask ) == ( IPLayerInstance -> MyLocalIPAddress & IPLayerInstance -> MyLocalNetMask ) )
      {
        TargetAddress = DestIPAddress & ( ~ IPLayerInstance -> MyLocalNetMask ) ;
        if ( TargetAddress == ( ~ IPLayerInstance -> MyLocalNetMask ) )
          BCMode = ( 1 ) ;
        TargetAddress = DestIPAddress ;
      }  
      else
      {
        TargetAddress = IPLayerInstance-> MyDefaultGWIPAddress ;
        if ( ! TargetAddress )
        {
          return ( 3 ) ;
        }   ;
      }   ;
    }   ;
    OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
    if ( OutFrame )
    {
      StartEthFrame ( OutFrame , ( void * ) 0 , InterfInstance -> InterfaceMACAddress , 0x0800 ) ;
      CreateIPHeader ( OutFrame , 17 , IPLayerInstance -> MyLocalIPAddress , DestIPAddress ) ;
      PutUSHORTSwapField ( OutFrame , 14 + 2 , 20 + 8 + DataSize ) ;
      CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 0 ] , 20 ) ;
      PutUSHORTNoSwapField ( OutFrame , 14 + 10 , CheckSum ) ;
      AllUDPDataBuffer = ( void * ) ( OutFrame -> Data + OutFrame -> Length ) ;
      AddUSHORTSwapField ( OutFrame , Socket -> ListenPortNo ) ;
      AddUSHORTSwapField ( OutFrame , DestPortNo ) ;
      AddUSHORTSwapField ( OutFrame , DataSize + 8 ) ;
      CheckSumOffset = OutFrame -> Length ;
      AddUSHORTSwapField ( OutFrame , 0 ) ;    
      AddByteArrayField ( OutFrame , DataBufferPtr , DataSize ) ;
      CheckSum = CalculateUDPChecksum ( IPLayerInstance -> MyLocalIPAddress , DestIPAddress ,
                                        AllUDPDataBuffer , 
                                        OutFrame -> Length - 14 - 20 ) ;
      if ( ! CheckSum )
        CheckSum = 0xFFFF ;
      PutUSHORTSwapField ( OutFrame , CheckSumOffset , CheckSum ) ;
TraceUDPHeader ( OutFrame ) ;
      if ( BCMode )
      {
        for ( Loop = 0 ; Loop < 6 ; Loop ++ )
          OutFrame -> Data [ Loop ] = 0xFF ;
TraceFrame(OutFrame);
        InterfInstance -> InterfaceSendFrame ( OutFrame ) ;
      }  
      else
      {
        IPLayerInstance -> SendIPPackedService ( IPLayerInstance , OutFrame , TargetAddress ) ;
      }   ;
      InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
      return ( 0 ) ;
    }   ;
  }   ;
  return ( 1 ) ;
}  


void SetDefaultUDPListen ( PtrUDPLayerInstanceRecT  UDPLayerInstance ,
                           AnyUDPRecvEventServProcT DefaultUDPDataConsumer )
{
  UDPLayerInstance -> DefaultListenService = DefaultUDPDataConsumer ;
}  


PtrUDPSocketDescriptionRecT CreateUDPSocket ( PtrUDPLayerInstanceRecT UDPLayerInstance )
{
  PtrUDPSocketDescriptionRecT NewSocket ;
   
  NewSocket = AllocateUDPSocket ( UDPLayerInstance ) ;
  return ( NewSocket ) ;
}  


void SetUDPListen ( PtrUDPSocketDescriptionRecT UDPSocket ,
                    SocketUDPRecvEventServProcT UDPDataConsumer )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
   
  UDPLayerInstance = UDPSocket -> UDPLayerInstanceLink ;
  UDPSocket -> ListenService = UDPDataConsumer ;
  UDPSocket -> NextSocketLink = UDPLayerInstance -> ListenSocketTopEntry ;
  UDPLayerInstance -> ListenSocketTopEntry = UDPSocket ;
}  


void UDPInitInstance ( PtrUDPLayerInstanceRecT UDPLayerInstance ,
                       PtrIPLayerInstanceRecT  IPLayerInstance )
{
  USHORT Loop ;
   
  UDPLayerInstance -> IPLayerInstance = IPLayerInstance ;
  UDPLayerInstance -> DefaultListenService = KillUDPData ;
  UDPLayerInstance -> ListenSocketTopEntry = ( void * ) 0 ;
  UDPLayerInstance -> LastLocalPort = 2048 ;
  IPLayerInstance -> UDPProcessService = ProcessUDPPacked ;
  IPLayerInstance -> UDPInstanceEntry = UDPLayerInstance ;
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
    UDPSocketSwitch [ Loop ] = 0 ;
}  


PtrUDPLayerInstanceRecT GetUDPInstance ( PtrUDPSocketDescriptionRecT UDPSocket )
{
  return ( UDPSocket -> UDPLayerInstanceLink ) ;
}  


PtrIPLayerInstanceRecT GetIPInstanceFromUDPInstance ( PtrUDPLayerInstanceRecT UDPLayerInstance )
{
  return ( UDPLayerInstance -> IPLayerInstance ) ;
}  


static UDPLayerInstanceRecT LocalUDPLayerInstance ;
PtrUDPLayerInstanceRecT StandardAddUDPInstance ( PtrIPLayerInstanceRecT IPLayerInstance )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
   
  UDPLayerInstance = & LocalUDPLayerInstance ;
  UDPInitInstance ( UDPLayerInstance , IPLayerInstance ) ;
  return ( UDPLayerInstance ) ;
}  

