/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                       Copyright (C) A. P. H.                           **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                      MODULE DHCP Protocol Service                      **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _dhcpservice_
#define _dhcpservice_

#include "udpservice.h"
#include "types.h"
#include "systime.h"


typedef void ( * RecVDHCPDataNotifyServProcT ) ( PtrUDPSocketDescriptionRecT /* DHCPSocket   */ ,
                                                 ULONG                       /* NewIPAddress */ ,
                                                 ULONG                       /* NewNetMask   */ ,
                                                 ULONG                       /* NewGWAddress */ ) ;

#define DeviceNameSize                16

typedef struct { PtrUDPLayerInstanceRecT      UDPLayerInstance ;
                 RecVDHCPDataNotifyServProcT  UserDCHPDataNotifyService ;
                 PtrUDPSocketDescriptionRecT  DHCPSocket ;
                 UCHAR                        DeviceName [ DeviceNameSize ] ;
                 ULONG                        XID ;
                 ULONG                        TimeOut ;
                 ULONG                        Client_IP ;
                 ULONG                        Server_ID ;
                 PtrTimeQueueRecT             TimeOutService ;
                 USHORT                       Command ;
                 USHORT                       Retry ;
               } DHCPLayerInstanceRecT ;
typedef DHCPLayerInstanceRecT * PtrDHCPLayerInstanceRecT ;


extern void DHCPClientRenew ( PtrDHCPLayerInstanceRecT /* DHCPInstance */ ) ;

extern USHORT StartDHCPService ( PtrDHCPLayerInstanceRecT    /* DHCPInstance      */ ,
                                 RecVDHCPDataNotifyServProcT /* DataNotifyService */ ) ;

extern void StopDHCPService ( PtrDHCPLayerInstanceRecT /* DHCPInstance */ ) ;

extern PtrDHCPLayerInstanceRecT AllocateDHCPClientInstance ( PtrUDPLayerInstanceRecT /* UDPLayerInstance */ ,
                                                             UCHAR *                 /* DeviceIdentifier */ ) ;


#endif
